﻿@using DevExpress.Web.Mvc; 
@using DevExpress.Web.Mvc.UI;
@using System.Web.UI.WebControls
@using Portal.Models.Forecast;
@using Portal.Controllers;
@using Toyota.Common.Web.Credential;

@model Toyota.Common.Web.MVC.ModelHolder
           
@Html.Common().DevExpress().GridView(
        gridView =>
        {
            gridView.Name = "ForecastDetailView";

            gridView.CallbackRouteValues = new { Controller = "Forecast", Action = "PartialDetailForecast" };
            gridView.ClientSideEvents.Init = "OnForecastDetailViewInit";
            gridView.ClientSideEvents.BeginCallback = "OnForecastDetailViewBeginCallback";
            gridView.ClientSideEvents.EndCallback = "OnForecastDetailViewEndCallback";
            gridView.ClientSideEvents.RowClick = "OnForecastDetailViewRowClick";

            gridView.Styles.Header.HorizontalAlign = HorizontalAlign.Center;
            gridView.Width = Unit.Percentage(100);

            gridView.Settings.ShowFilterRow = true;
            gridView.Settings.ShowFilterRowMenu = true;
            //gridView.Settings.ShowHorizontalScrollBar = true;
            gridView.Settings.HorizontalScrollBarMode = ScrollBarMode.Auto;
            //gridView.Settings.ShowVerticalScrollBar = false;
            gridView.Settings.VerticalScrollBarMode = ScrollBarMode.Hidden;
            gridView.Settings.ShowColumnHeaders = true;
            gridView.CommandColumn.ClearFilterButton.Visible = true;
            
            gridView.KeyFieldName = "PRODUCTION_MONTH;SUPPLIER_CD;SUPPLIER_PLANT;T_LOCK_STATUS;F_LOCK_STATUS";

            gridView.CustomJSProperties = (s, e) =>
            {
                MVCxGridView grid = (MVCxGridView)s;
                int startIndex = grid.PageIndex * grid.SettingsPager.PageSize;
                int end = Math.Min(grid.VisibleRowCount, startIndex + grid.SettingsPager.PageSize);

                //int startIndex = 0;
                //int end = Model.GetModel<ForecastModelList>().Collection.Count;

                object[] ProductionMonth = new object[end - startIndex];
                object[] SupplierCd = new object[end - startIndex];
                object[] SupplierPlant = new object[end - startIndex];
                object[] TLockStatus = new object[end - startIndex];
                object[] FLockStatus = new object[end - startIndex];
                
                for (int n = startIndex; n < end; n++)
                {
                    ProductionMonth[n - startIndex] = grid.GetRowValues(n, "PRODUCTION_MONTH");
                    SupplierCd[n - startIndex] = grid.GetRowValues(n, "SUPPLIER_CD");
                    SupplierPlant[n - startIndex] = grid.GetRowValues(n, "SUPPLIER_PLANT");
                    TLockStatus[n - startIndex] = grid.GetRowValues(n, "T_LOCK_STATUS");
                    FLockStatus[n - startIndex] = grid.GetRowValues(n, "F_LOCK_STATUS");
                }
                e.Properties["cpProductionMonth"] = ProductionMonth;
                e.Properties["cpSupplierCd"] = SupplierCd;
                e.Properties["cpSupplierPlant"] = SupplierPlant;
                e.Properties["cpTLockStatus"] = TLockStatus;
                e.Properties["cpFLockStatus"] = FLockStatus;

                grid.JSProperties["cpPageSize"] = grid.SettingsPager.PageSize;
            };
            object dataItem;

            #region New gridview column list, By Salman Alfarizi 21-peb-2013
            gridView.Columns.Add(
                column =>
                {
                    column.Caption = "Production<br />Month";
                    column.Name = "ProductionMonth";
                    column.FieldName = "PRODUCTION_MONTH";

                    column.Width = Unit.Pixel(70);
                    column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                    column.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    column.ColumnType = MVCxGridViewColumnType.DateEdit;
                    column.SetDataItemTemplateContent(
                        content =>
                        {
                            Html.DevExpress().Label(
                                label =>
                                {
                                    label.Name = "FDProductionMonthLabel" + content.VisibleIndex;
                                    dataItem = DataBinder.Eval(content.DataItem, "PRODUCTION_MONTH");

                                    var fr = new System.Globalization.CultureInfo("fr-FR");
                                    DateTime getSudoMonth = DateTime.ParseExact(Convert.ToString(dataItem), "yyyyMM", System.Globalization.CultureInfo.CurrentCulture);
                                    label.Text = String.Format("{0:MMM-yy}", getSudoMonth);
                                }).Render();
                        });
                });
            gridView.Columns.Add(
             column =>
             {
                 column.Caption = "Supplier<br />Plant";
                 column.Name = "SupplierCode";
                 column.FieldName = "SUPPLIER_CD_PLANT";

                 column.Width = Unit.Pixel(60);
                 column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                 column.CellStyle.VerticalAlign = VerticalAlign.Middle;
                 column.ColumnType = MVCxGridViewColumnType.TextBox;                 
             });

            gridView.Columns.Add(
                column =>
                {
                    column.Caption = "Supplier Name";
                    column.Name = "SupplierName";
                    column.FieldName = "SUPPLIER_NAME";
                    
                    column.Width = Unit.Pixel(250);
                    column.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                    column.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    column.ColumnType = MVCxGridViewColumnType.TextBox;
                });

            gridView.Columns.AddBand(
                columnBand =>
                {
                    columnBand.Caption = "Tentative LPOP";

                    columnBand.Columns.Add(
                        column =>
                        {
                            // field properties
                            column.Caption = "File";
                            column.Name = "LPOPTFile";
                            //column.FieldName = "LPOP_T_STATUS";

                            column.Width = Unit.Pixel(64);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.CellStyle.VerticalAlign = VerticalAlign.Middle;

                            column.SetDataItemTemplateContent(
                                content =>
                                {
                                    Html.DevExpress().Image(
                                        image =>
                                        {
                                            image.Name = "FDLPOPTFileImage" + content.VisibleIndex;
                                            image.Properties.ImageAlign = ImageAlign.Middle;
                                            image.Properties.ClientSideEvents.Click = "OnFDLPOPTFileImageClick";
                                            image.ControlStyle.Cursor = "pointer";

                                            dataItem = DataBinder.Eval(content.DataItem, "LPOP_T_STATUS");
                                            if (dataItem != null)
                                            {
                                                if (Convert.ToBoolean(Convert.ToString(dataItem).Equals("1")) || Convert.ToBoolean(Convert.ToString(dataItem).Equals("2")) ? true : false)
                                                {
                                                    image.ImageUrl = "~/Content/Images/xls_icon.png";
                                                }
                                                else
                                                {
                                                    image.Style.Add("visibility", "hidden");
                                                }
                                            }
                                            else
                                            {
                                                image.Style.Add("visibility", "hidden");
                                            }
                                        }).Render();
                                });
                        });

                    columnBand.Columns.Add(
                        column =>
                        {
                            // field properties
                            column.Caption = "Status";
                            column.Name = "LPOPTStatus";
                            column.FieldName = "LPOP_T_STATUS";

                            column.Width = Unit.Pixel(64);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.CellStyle.VerticalAlign = VerticalAlign.Middle;

                            column.SetDataItemTemplateContent(
                                content =>
                                {
                                    Html.DevExpress().Image(
                                        image =>
                                        {
                                            
                                            image.Properties.ImageAlign = ImageAlign.Middle;

                                            dataItem = DataBinder.Eval(content.DataItem, "LPOP_T_STATUS");
                                            if (dataItem != null)
                                            {
                                                if (Convert.ToBoolean((Convert.ToString(dataItem).Equals("2") ? true : false)))
                                                {
                                                    image.ImageUrl = "~/Content/Images/ok_icon.png";
                                                }
                                                else
                                                {
                                                    image.Style.Add("visibility", "hidden");
                                                }
                                            }
                                            else
                                            {
                                                image.Style.Add("visibility", "hidden");
                                            }
                                        }).Render();
                                });

                            /*
                             * Note by : fid.salman (24-jan-2013)
                             * Note    :
                             * 1. column.PropertiesEdit depend on field data type in database, which is according column.Settings.FilterMode
                             * 2. comboSetting.Items.Add([text], [value]) => [value] also must compatible with field data type in database.
                             * 3. Make sure each column filter, filtered each column with difference FieldName source.
                             */

                            // field filter control
                            column.Settings.FilterMode = ColumnFilterMode.Value;
                            column.ColumnType = MVCxGridViewColumnType.ComboBox;

                            var comboSetting = column.PropertiesEdit as ComboBoxProperties;
                            comboSetting.Items.Add("All", "");
                            comboSetting.Items.Add("Downloaded", "2");
                            comboSetting.Items.Add("Not Downloaded", "1");
                        });

                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "Supplier<br />Feedback";
                            column.Name = "LPOPTFeedbackReply";
                            //column.FieldName = "T_FEEDBACK_REPLY";

                            column.Width = Unit.Pixel(64);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.CellStyle.VerticalAlign = VerticalAlign.Middle;

                            column.SetDataItemTemplateContent(
                                content =>
                                {
                                    GridViewDataItemTemplateContainer c = (GridViewDataItemTemplateContainer)content;
                                    Html.DevExpress().HyperLink(
                                        link =>
                                        {
                                            link.Name = string.Format("FDLPOPTFeedbackReplyLink_{0}", c.VisibleIndex);
                                            link.NavigateUrl = "javascript:void(0)";
                                            link.Properties.ClientSideEvents.Click = "function(s,e) { OnFDLPOPTFeedbackReplyLinkClick(s,e,'FDNoticeMessage_" + DataBinder.Eval(c.DataItem, "SUPPLIER_CD") + "_" + DataBinder.Eval(c.DataItem, "SUPPLIER_PLANT") + "'); }";
                                            link.Properties.Text = "View";
                                            link.ClientVisible = true;
                                        }).Render();
                                });

                            // authorization code
                            var authorized = Model.GetModel<User>().IsAuthorized("Forecast", "LPOPTFeedbackReply");
                            if (authorized == 0)
                            {
                                column.Visible = false;
                            }
                            if (authorized == 1)
                            {
                                column.Visible = true;
                                column.ReadOnly = true;
                            }
                            if (authorized == 2)
                            {
                                column.Visible = true;
                            }
                            if (authorized == null)
                            {
                                column.Visible = true;
                            } 
                        });

                    columnBand.Columns.Add(
                        column =>
                        {
                            // field properties
                            column.Caption = "Feedback<br />Status";
                            column.Name = "LPOPTFeedbackStatus";
                            column.FieldName = "T_FEEDBACK_STATUS";

                            column.Width = Unit.Pixel(64);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.CellStyle.VerticalAlign = VerticalAlign.Middle;

                            column.SetDataItemTemplateContent(
                                content =>
                                {
                                    Html.DevExpress().Label(
                                        label =>
                                        {
                                            label.Name = "FDLPOPTFeedbackStatusLabel" + content.VisibleIndex;
                                            label.ControlStyle.HorizontalAlign = HorizontalAlign.Center;
                                            label.ControlStyle.VerticalAlign = VerticalAlign.Middle;
                                            dataItem = DataBinder.Eval(content.DataItem, "T_FEEDBACK_STATUS");

                                            if (dataItem != null)
                                            {
                                                if (!Convert.ToBoolean(dataItem))
                                                { label.Text = "OK"; }
                                                else
                                                { label.Text = "NG"; }
                                            }
                                            else
                                            {
                                                label.Style.Add("visibility", "hidden");
                                            }

                                        }).Render();
                                });

                            // field filter properties
                            column.Settings.FilterMode = ColumnFilterMode.Value;
                            column.ColumnType = MVCxGridViewColumnType.ComboBox;

                            var comboSetting = column.PropertiesEdit as ComboBoxProperties;
                            comboSetting.Items.Add("All", "");
                            comboSetting.Items.Add("OK", DefaultBoolean.False);
                            comboSetting.Items.Add("NG", DefaultBoolean.True);
                        });
                });

            gridView.Columns.Add(
                column =>
                {
                    // field properties
                    column.Caption = "Unlock";
                    column.Name = "TentativeUnlock";
                    column.FieldName = "T_LOCK_STATUS";

                    column.Width = Unit.Pixel(64);
                    column.ColumnType = MVCxGridViewColumnType.TextBox;
                    column.CellStyle.HorizontalAlign = HorizontalAlign.Center;

                    column.SetDataItemTemplateContent(
                        content =>
                        {
                            Html.DevExpress().Image(
                                image =>
                                {
                                    image.Name = "FDTentativeUnlockImage" + content.VisibleIndex;
                                    image.Properties.ImageAlign = ImageAlign.Middle;
                                    image.Properties.ClientSideEvents.Click = "OnFDTentativeUnlockImageClick";
                                    image.ControlStyle.Cursor = "pointer";

                                    dataItem = DataBinder.Eval(content.DataItem, "T_LOCK_STATUS");
                                    if (dataItem != null)
                                    {
                                        if (Convert.ToBoolean(dataItem))
                                        { image.ImageUrl = "~/Content/Images/Lock-icon.png"; }
                                        else
                                        { image.ImageUrl = "~/Content/Images/Unlock-icon.png"; }
                                    }
                                    else
                                    {
                                        image.Style.Add("visibility", "hidden");
                                    }
                                }).Render();
                            
                        });
                    
                    // authorization code
                    var authorized = Model.GetModel<User>().IsAuthorized("Forecast", "TentativeUnlock");
                    if (authorized == 0)
                    {
                        column.Visible = false;
                    } 
                    if (authorized == 1)
                    {
                        column.Visible = true;
                        column.ReadOnly = true;
                    }
                    if (authorized == 2)
                    {
                        column.Visible = true;
                    }
                    if (authorized == null)
                    {
                        column.Visible = true;
                    } 
                        

                    // field filter properties
                    column.Settings.FilterMode = ColumnFilterMode.Value;
                    column.ColumnType = MVCxGridViewColumnType.ComboBox;

                    var comboSetting = column.PropertiesEdit as ComboBoxProperties;
                    comboSetting.Items.Add("All", "");
                    comboSetting.Items.Add("LOCK", DefaultBoolean.True);
                    comboSetting.Items.Add("UNLOCK", DefaultBoolean.False);
                });

            gridView.Columns.AddBand(
                columnBand =>
                {
                    columnBand.Caption = "Firm LPOP";

                    columnBand.Columns.Add(
                        column =>
                        {
                            // field properties
                            column.Caption = "File";
                            column.Name = "LPOPFFile";
                            //column.FieldName = "FirmDownloadStatus";

                            column.Width = Unit.Pixel(64);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.CellStyle.VerticalAlign = VerticalAlign.Middle;

                            column.SetDataItemTemplateContent(
                                content =>
                                {
                                    Html.DevExpress().Image(
                                        image =>
                                        {
                                            image.Name = "FDLPOPFFileImage" + content.VisibleIndex;
                                            image.Properties.ImageAlign = ImageAlign.Middle;
                                            image.Properties.ClientSideEvents.Click = "OnFDLPOPFFileImageClick";
                                            image.ControlStyle.Cursor = "pointer";
                                            
                                            dataItem = DataBinder.Eval(content.DataItem, "LPOP_F_STATUS");
                                            if (dataItem != null)
                                            {
                                                if (Convert.ToBoolean(Convert.ToString(dataItem).Equals("1")) || Convert.ToBoolean(Convert.ToString(dataItem).Equals("2")) ? true : false)
                                                {
                                                    image.ImageUrl = "~/Content/Images/xls_icon.png";
                                                }
                                                else
                                                {
                                                    image.Style.Add("visibility", "hidden");
                                                }
                                            }
                                            else
                                            {
                                                image.Style.Add("visibility", "hidden");
                                            }
                                        }).Render();
                                });
                        });

                    columnBand.Columns.Add(
                        column =>
                        {
                            // field properties
                            column.Caption = "Status";
                            column.Name = "LPOPFStatus";
                            column.FieldName = "LPOP_F_STATUS";

                            column.Width = Unit.Pixel(64);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.CellStyle.VerticalAlign = VerticalAlign.Middle;

                            column.SetDataItemTemplateContent(
                                content =>
                                {
                                    Html.DevExpress().Image(
                                        image =>
                                        {

                                            image.Properties.ImageAlign = ImageAlign.Middle;

                                            dataItem = DataBinder.Eval(content.DataItem, "LPOP_F_STATUS");
                                            if (dataItem != null)
                                            {
                                                if (Convert.ToBoolean((Convert.ToString(dataItem).Equals("2") ? true : false)))
                                                {
                                                    image.ImageUrl = "~/Content/Images/ok_icon.png";
                                                }
                                                else
                                                {
                                                    image.Style.Add("visibility", "hidden");
                                                }
                                            }
                                            else
                                            {
                                                image.Style.Add("visibility", "hidden");
                                            }
                                        }).Render();
                                });

                            // field filter properties
                            column.Settings.FilterMode = ColumnFilterMode.Value;
                            column.ColumnType = MVCxGridViewColumnType.ComboBox;

                            var comboSetting = column.PropertiesEdit as ComboBoxProperties;
                            comboSetting.Items.Add("All", "");
                            comboSetting.Items.Add("Downloaded", "2");
                            comboSetting.Items.Add("Not Downloaded", "1");
                        });

                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "Supplier<br />Feedback";
                            column.Name = "LPOPFFeedbackReply";
                            //column.FieldName = "F_FEEDBACK_REPLY";

                            column.Width = Unit.Pixel(64);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.CellStyle.VerticalAlign = VerticalAlign.Middle;

                            column.SetDataItemTemplateContent(
                                content =>
                                {
                                    GridViewDataItemTemplateContainer c = (GridViewDataItemTemplateContainer)content;
                                    Html.DevExpress().HyperLink(
                                        link =>
                                        {
                                            link.Name = string.Format("FDLPOPFFeedbackReplyLink_{0}", (content as GridViewDataItemTemplateContainer).VisibleIndex);
                                            link.NavigateUrl = "javascript:void(0)";
                                            link.Properties.ClientSideEvents.Click = "function(s,e) { OnFDLPOPFFeedbackReplyLinkClick(s,e,'FDNoticeMessage_" + DataBinder.Eval(c.DataItem, "SUPPLIER_CD") + "_" + DataBinder.Eval(c.DataItem, "SUPPLIER_PLANT") + "'); }";
                                            link.Properties.Text = "View";
                                            link.ClientVisible = true;
                                        }).Render();
                                });

                            // authorization code
                            var authorized = Model.GetModel<User>().IsAuthorized("Forecast", "LPOPFFeedbackReply");
                            if (authorized == 0)
                            {
                                column.Visible = false;
                            }
                            if (authorized == 1)
                            {
                                column.Visible = true;
                                column.ReadOnly = true;
                            }
                            if (authorized == 2)
                            {
                                column.Visible = true;
                            }
                            if (authorized == null)
                            {
                                column.Visible = true;
                            } 
                        });

                    columnBand.Columns.Add(
                        column =>
                        {
                            // field properties
                            column.Caption = "Feedback<br />Status";
                            column.Name = "LPOPFFeedbackStatus";
                            column.FieldName = "F_FEEDBACK_STATUS";

                            column.Width = Unit.Pixel(64);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.CellStyle.VerticalAlign = VerticalAlign.Middle;

                            column.SetDataItemTemplateContent(
                                content =>
                                {
                                    Html.DevExpress().Label(
                                        label =>
                                        {
                                            label.Name = "FDLPOPFFeedbackStatusLabel" + content.VisibleIndex;
                                            label.ControlStyle.HorizontalAlign = HorizontalAlign.Center;
                                            label.ControlStyle.VerticalAlign = VerticalAlign.Middle;

                                            dataItem = DataBinder.Eval(content.DataItem, "F_FEEDBACK_STATUS");

                                            if (dataItem != null)
                                            {
                                                if (!Convert.ToBoolean(dataItem))
                                                {
                                                    label.Text = "OK";
                                                }
                                                else
                                                {
                                                    label.Text = "NG";
                                                }
                                            }
                                            else
                                            {
                                                label.Style.Add("visibility", "hidden");
                                            }
                                        }).Render();
                                });

                            // field filter properties
                            column.Settings.FilterMode = ColumnFilterMode.Value;
                            column.ColumnType = MVCxGridViewColumnType.ComboBox;

                            var comboSetting = column.PropertiesEdit as ComboBoxProperties;
                            comboSetting.Items.Add("All", "");
                            comboSetting.Items.Add("OK", DefaultBoolean.False);
                            comboSetting.Items.Add("NG", DefaultBoolean.True);
                        });
                });

            gridView.Columns.Add(
                column =>
                {
                    // field properties
                    column.Caption = "Unlock";
                    column.Name = "FirmUnlock";
                    column.FieldName = "F_LOCK_STATUS";

                    column.Width = Unit.Pixel(64);
                    column.ColumnType = MVCxGridViewColumnType.TextBox;
                    column.CellStyle.HorizontalAlign = HorizontalAlign.Center;

                    column.SetDataItemTemplateContent(
                        content =>
                        {
                            Html.DevExpress().Image(
                                image =>
                                {
                                    image.Name = "FDFirmUnlockImage" + content.VisibleIndex;
                                    image.Properties.ImageAlign = ImageAlign.Middle;
                                    image.Properties.ClientSideEvents.Click = "OnFDFirmUnlockImageClick";
                                    image.ControlStyle.Cursor = "pointer";

                                    dataItem = DataBinder.Eval(content.DataItem, "F_LOCK_STATUS");
                                    if (dataItem != null)
                                    {
                                        if (Convert.ToBoolean(dataItem))
                                        {
                                            image.ImageUrl = "~/Content/Images/Lock-icon.png";
                                        }
                                        else
                                        {
                                            image.ImageUrl = "~/Content/Images/Unlock-icon.png";
                                        }
                                    }
                                    else
                                    {
                                        image.Style.Add("visibility", "hidden");
                                    }
                                }).Render();
                        });

                    // authorization code
                    var authorized = Model.GetModel<User>().IsAuthorized("Forecast", "FirmUnlock");
                    if (authorized == 0)
                    {
                        column.Visible = false;
                    }
                    if (authorized == 1)
                    {
                        column.Visible = true;
                        column.ReadOnly = true;
                    }
                    if (authorized == 2)
                    {
                        column.Visible = true;
                    }
                    if (authorized == null)
                    {
                        column.Visible = true;
                    }
                    
                    // field filter properties
                    column.Settings.FilterMode = ColumnFilterMode.Value;
                    column.ColumnType = MVCxGridViewColumnType.ComboBox;

                    var comboSetting = column.PropertiesEdit as ComboBoxProperties;
                    comboSetting.Items.Add("All", "");
                    comboSetting.Items.Add("LOCK", DefaultBoolean.True);
                    comboSetting.Items.Add("UNLOCK", DefaultBoolean.False);
                });

            gridView.Columns.Add(
                column =>
                {
                    column.Caption = "Feedback<br />Summary";
                    column.Name = "Summary";

                    column.Width = Unit.Pixel(64);
                    column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                    column.CellStyle.VerticalAlign = VerticalAlign.Middle;

                    column.SetDataItemTemplateContent(
                        content =>
                        {
                            DevExpressHelper.WriteLineToResponse(
                                Html.ActionLink(
                                    "View",
                                    "Index",
                                    "SupplierFeedbackSummary",
                                    new
                                    {
                                        ProductionMonth = Convert.ToString(DataBinder.Eval(content.DataItem, "PRODUCTION_MONTH")),
                                        Timing = "",
                                        SupplierCode = Convert.ToString(DataBinder.Eval(content.DataItem, "SUPPLIER_CD")),
                                        SupplierPlantCode = Convert.ToString(DataBinder.Eval(content.DataItem, "SUPPLIER_PLANT"))
                                    },
                                    new object[] { }).ToString());
                        });
                    
                    // authorization code
                    var authorized = Model.GetModel<User>().IsAuthorized("Forecast", "Summary");
                    if (authorized == 0)
                    {
                        column.Visible = false;
                    }
                    if (authorized == 1)
                    {
                        column.Visible = true;
                        column.ReadOnly = true;
                    }
                    if (authorized == 2)
                    {
                        column.Visible = true;
                    }
                    if (authorized == null)
                    {
                        column.Visible = true;
                    }
                });

            gridView.Columns.Add(
                column =>
                {
                    column.Caption = "Detail<br />Data";
                    column.Name = "DetailData";

                    column.Width = Unit.Pixel(64);
                    column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                    column.CellStyle.VerticalAlign = VerticalAlign.Middle;

                    column.SetDataItemTemplateContent(
                        content =>
                        {
                            Html.DevExpress().HyperLink(
                                link =>
                                {
                                    link.Name = string.Format("FDDetailDataViewLink_{0}", (content as GridViewDataItemTemplateContainer).VisibleIndex);
                                    link.NavigateUrl = "javascript:void(0)";
                                    link.Properties.ClientSideEvents.Click = "OnFDDetailDataViewLinkClick";
                                    link.Properties.Text = "View";
                                }).Render();
                        });
                });

            gridView.Columns.Add(
                column =>
                {
                    // field properties
                    column.Caption = "Notice";
                    column.Name = "Notice";
                    column.FieldName = "NOTICE";

                    column.Width = Unit.Pixel(64);
                    column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                    column.CellStyle.VerticalAlign = VerticalAlign.Middle;

                    column.SetDataItemTemplateContent(
                        content =>
                        {
                            @Html.Common().DevExpress().MessageBoardOpenImage(
                                imgsettings =>
                                {
                                    imgsettings.Name = "FDNoticeMessage" + content.VisibleIndex;
                                    imgsettings.BoardId = "ForecastMessageBoard";
                                    imgsettings.BoardName = "FDNoticeMessage_" + DataBinder.Eval(content.DataItem, "SUPPLIER_CD") + "_" + DataBinder.Eval(content.DataItem, "SUPPLIER_PLANT");
                                }).Render();
                        });

                    // field filter properties
                    column.Settings.FilterMode = ColumnFilterMode.Value;
                    column.ColumnType = MVCxGridViewColumnType.ComboBox;

                    var comboSetting = column.PropertiesEdit as ComboBoxProperties;
                    comboSetting.Items.Add("Empty", "~/Content/Images/notice_add_icon.png", "~/Content/Images/notice_add_icon.png");
                    comboSetting.Items.Add("New", "~/Content/Images/notice_new_icon.png", "~/Content/Images/notice_new_icon.png");
                    comboSetting.Items.Add("Read", "~/Content/Images/notice_open_icon.png", "~/Content/Images/notice_open_icon.png");
                    comboSetting.Items.Add("Close", "~/Content/Images/notice_close_icon.png", "~/Content/Images/notice_close_icon.png");
                });

            gridView.Columns.AddBand(
                columnBand =>
                {
                    columnBand.Caption = "PO";

                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "Po No";
                            column.FieldName = "PO_NO";
                            column.Width = Unit.Pixel(80);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
                            column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.CellStyle.Wrap = DefaultBoolean.False;
                            column.SetDataItemTemplateContent(
                                content =>
                                {
                                    Html.DevExpress().Label(
                                        label =>
                                        {
                                            label.Name = "FDLPOPPONo" + content.VisibleIndex;
                                            label.ControlStyle.HorizontalAlign = HorizontalAlign.Center;
                                            label.ControlStyle.VerticalAlign = VerticalAlign.Middle;
                                            label.Text = DataBinder.Eval(Model.GetModel<ForecastModelList>().Collection[content.VisibleIndex], "PO_NO").ToString().Length > 0 ? 
                                                        (content as GridViewDataItemTemplateContainer).Text : "";
                                        }).Render();
                                });
                        });
                    
                    columnBand.Columns.Add(
                        column =>
                        {
                            // field properties
                            column.Caption = "File";
                            column.Name = "POFile";

                            column.Width = Unit.Pixel(64);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.CellStyle.VerticalAlign = VerticalAlign.Middle;

                            column.SetDataItemTemplateContent(
                                content =>
                                {
                                    Html.DevExpress().HyperLink(
                                        hlSettings =>
                                        {
                                            hlSettings.Name = "FDLPOPPOFileImage" + content.VisibleIndex;
                                            hlSettings.NavigateUrl = "javascript:void(0)";
                                            hlSettings.Properties.ClientSideEvents.Click = "DownloadCoverPOPDF";
                                            hlSettings.Properties.ImageUrl = "~/Content/Images/pdf_icon.png";
                                            hlSettings.ClientVisible = (DataBinder.Eval(content.DataItem, "RELEASE_DT") != null ? true : false);
                                        }).Render();
                                });
                        });
                });
            
            gridView.Columns.AddBand(
                columnBand =>
                {
                    columnBand.Caption = "Tentative LPOP Download";
                    columnBand.Name = "TDownload";
                    columnBand.Visible = false;

                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "PIC";
                            column.Name = "TDownloadUser";
                            column.FieldName = "T_LPOP_DOWNLOADER";

                            column.Width = Unit.Pixel(120);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
                        });

                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "Date";
                            column.Name = "TDownloadDate";
                            column.FieldName = "T_LPOP_DOWNLOAD_DT";

                            column.Width = Unit.Pixel(120);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.CellStyle.VerticalAlign = VerticalAlign.Middle;

                            column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy hh:mm";
                            column.CellStyle.Wrap = DefaultBoolean.False;
                            column.ColumnType = MVCxGridViewColumnType.DateEdit;

                            column.SetDataItemTemplateContent(
                                content =>
                                {
                                    Html.DevExpress().Label(
                                        label =>
                                        {
                                            label.Name = "GRIDTDownloadDateLabel" + content.VisibleIndex;
                                            label.ControlStyle.HorizontalAlign = HorizontalAlign.Center;
                                            label.ControlStyle.VerticalAlign = VerticalAlign.Middle;
                                            dataItem = DataBinder.Eval(content.DataItem, "T_LPOP_DOWNLOAD_DT");

                                            if (dataItem != null)
                                            {
                                                label.Text = Convert.ToDateTime(dataItem).ToString("dd.MM.yyyy hh:mm");
                                                label.ClientVisible = true;
                                            }
                                            else
                                            {
                                                label.ClientVisible = false;
                                            }
                                        }).Render();
                                });
                        });
                });

            gridView.Columns.AddBand(
                columnBand =>
                {
                    columnBand.Caption = "Firm LPOP Download";
                    columnBand.Name = "FDownload";
                    columnBand.Visible = false;

                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "PIC";
                            column.Name = "FDownloadUser";
                            column.FieldName = "F_LPOP_DOWNLOADER";

                            column.Width = Unit.Pixel(120);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
                        });

                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "Date";
                            column.Name = "FDownloadDate";
                            column.FieldName = "F_LPOP_DOWNLOAD_DT";

                            column.Width = Unit.Pixel(120);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.CellStyle.VerticalAlign = VerticalAlign.Middle;

                            column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy hh:mm";
                            column.CellStyle.Wrap = DefaultBoolean.False;
                            column.ColumnType = MVCxGridViewColumnType.DateEdit;

                            column.SetDataItemTemplateContent(
                                content =>
                                {
                                    Html.DevExpress().Label(
                                        label =>
                                        {
                                            label.Name = "GRIDFDownloadDateLabel" + content.VisibleIndex;
                                            label.ControlStyle.HorizontalAlign = HorizontalAlign.Center;
                                            label.ControlStyle.VerticalAlign = VerticalAlign.Middle;
                                            dataItem = DataBinder.Eval(content.DataItem, "F_LPOP_DOWNLOAD_DT");

                                            if (dataItem != null)
                                            {
                                                label.Text = Convert.ToDateTime(dataItem).ToString("dd.MM.yyyy hh:mm");
                                                label.ClientVisible = true;
                                            }
                                            else
                                            {
                                                label.ClientVisible = false;
                                            }
                                        }).Render();
                                });
                        });
                });

            gridView.Columns.AddBand(
                columnBand =>
                {
                    columnBand.Caption = "PO Download";
                    columnBand.Name = "PODownload";
                    columnBand.Visible = false;

                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "PIC";
                            column.Name = "PODownloadUser";
                            column.FieldName = "PO_DOWNLOAD_USER";

                            column.Width = Unit.Pixel(120);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
                        });

                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "Date";
                            column.Name = "PODownloadDate";
                            column.FieldName = "PO_DOWNLOAD_DT";

                            column.Width = Unit.Pixel(120);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.CellStyle.VerticalAlign = VerticalAlign.Middle;

                            column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy hh:mm";
                            column.CellStyle.Wrap = DefaultBoolean.False;
                            column.ColumnType = MVCxGridViewColumnType.DateEdit;

                            column.SetDataItemTemplateContent(
                                content =>
                                {
                                    Html.DevExpress().Label(
                                        label =>
                                        {
                                            label.Name = "GRIDPODownloadDateLabel" + content.VisibleIndex;
                                            label.ControlStyle.HorizontalAlign = HorizontalAlign.Center;
                                            label.ControlStyle.VerticalAlign = VerticalAlign.Middle;
                                            dataItem = DataBinder.Eval(content.DataItem, "PO_DOWNLOAD_DT");

                                            if (dataItem != null)
                                            {
                                                label.Text = Convert.ToDateTime(dataItem).ToString("dd.MM.yyyy hh:mm");
                                                label.ClientVisible = true;
                                            }
                                            else
                                            {
                                                label.ClientVisible = false;
                                            }
                                        }).Render();
                                });
                        });
                });

            gridView.Columns.AddBand(
                columnBand =>
                {
                    columnBand.Caption = "Tentative Feedback Reply";
                    columnBand.Name = "TFeedback";
                    columnBand.Visible = false;

                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "PIC";
                            column.Name = "TFeedbackUser";
                            column.FieldName = "T_FEEDBACK_USER";

                            column.Width = Unit.Pixel(120);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
                        });

                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "Date";
                            column.Name = "TFeedbackDate";
                            column.FieldName = "T_FEEDBACK_DT";

                            column.Width = Unit.Pixel(120);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.CellStyle.VerticalAlign = VerticalAlign.Middle;

                            column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy hh:mm";
                            column.CellStyle.Wrap = DefaultBoolean.False;
                            column.ColumnType = MVCxGridViewColumnType.DateEdit;

                            column.SetDataItemTemplateContent(
                                content =>
                                {
                                    Html.DevExpress().Label(
                                        label =>
                                        {
                                            label.Name = "GRIDTFeedbackDateLabel" + content.VisibleIndex;
                                            label.ControlStyle.HorizontalAlign = HorizontalAlign.Center;
                                            label.ControlStyle.VerticalAlign = VerticalAlign.Middle;
                                            dataItem = DataBinder.Eval(content.DataItem, "T_FEEDBACK_DT");

                                            if (dataItem != null)
                                            {
                                                label.Text = Convert.ToDateTime(dataItem).ToString("dd.MM.yyyy hh:mm");
                                                label.ClientVisible = true;
                                            }
                                            else
                                            {
                                                label.ClientVisible = false;
                                            }
                                        }).Render();
                                });
                        });
                });

            gridView.Columns.AddBand(
                columnBand =>
                {
                    columnBand.Caption = "Firm Feedback Reply";
                    columnBand.Name = "FFeedback";
                    columnBand.Visible = false;

                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "PIC";
                            column.Name = "FFeedbackUser";
                            column.FieldName = "F_FEEDBACK_USER";

                            column.Width = Unit.Pixel(120);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
                        });

                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "Date";
                            column.Name = "FFeedbackDate";
                            column.FieldName = "F_FEEDBACK_DT";

                            column.Width = Unit.Pixel(120);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.CellStyle.VerticalAlign = VerticalAlign.Middle;

                            column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy hh:mm";
                            column.CellStyle.Wrap = DefaultBoolean.False;
                            column.ColumnType = MVCxGridViewColumnType.DateEdit;

                            column.SetDataItemTemplateContent(
                                content =>
                                {
                                    Html.DevExpress().Label(
                                        label =>
                                        {
                                            label.Name = "GRIDFFeedbackDateLabel" + content.VisibleIndex;
                                            label.ControlStyle.HorizontalAlign = HorizontalAlign.Center;
                                            label.ControlStyle.VerticalAlign = VerticalAlign.Middle;
                                            dataItem = DataBinder.Eval(content.DataItem, "F_FEEDBACK_DT");

                                            if (dataItem != null)
                                            {
                                                label.Text = Convert.ToDateTime(dataItem).ToString("dd.MM.yyyy hh:mm");
                                                label.ClientVisible = true;
                                            }
                                            else
                                            {
                                                label.ClientVisible = false;
                                            }
                                        }).Render();
                                });
                        });
                });
            #endregion New gridview column list, By Salman Alfarizi 15012013

            gridView.Settings.VerticalScrollBarMode = ScrollBarMode.Hidden;
            gridView.Settings.HorizontalScrollBarMode = ScrollBarMode.Visible;

            gridView.OnDemandPageSize = true;
            gridView.SettingsPager.PageSize = 4;
            gridView.Settings.VerticalScrollableHeight = 250;
            gridView.SettingsPager.FirstPageButton.Visible = true;
            gridView.SettingsPager.LastPageButton.Visible = true;
            gridView.SettingsPager.ShowNumericButtons = true;
            gridView.SettingsPager.Position = PagerPosition.Bottom;
            gridView.SettingsPager.PageSizeItemSettings.Visible = true;
            gridView.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
            gridView.SettingsPager.PageSizeItemSettings.Caption = "Page size";

            gridView.PreRender = (sender, e) =>
            {

            };
            gridView.HtmlDataCellPrepared = (sender, e) =>
            {
                if (e.DataColumn.FieldName == "T_FEEDBACK_STATUS")
                {
                    if (e.CellValue != null)
                    {
                        if (Convert.ToString(e.CellValue).ToLower().Equals("false"))
                        {
                            e.Cell.BackColor = e.DataColumn.CellStyle.BackColor;
                            e.Cell.ForeColor = System.Drawing.Color.Black;
                        }
                        else
                        {
                            e.Cell.BackColor = System.Drawing.Color.Red;
                            e.Cell.ForeColor = System.Drawing.Color.White;
                        }
                    }
                }
                if (e.DataColumn.FieldName == "F_FEEDBACK_STATUS")
                {
                    if (e.CellValue != null)
                    {
                        if (Convert.ToString(e.CellValue).ToLower().Equals("false"))
                        {
                            e.Cell.BackColor = e.DataColumn.CellStyle.BackColor;
                            e.Cell.ForeColor = System.Drawing.Color.Black;
                        }
                        else
                        {
                            e.Cell.BackColor = System.Drawing.Color.Red;
                            e.Cell.ForeColor = System.Drawing.Color.White;
                        }
                    }
                }
            };


        }).Bind(Model.GetModel<ForecastModelList>().Collection).GetHtml()